# $Id: hobbit.spec 350 2006-01-25 13:36:33Z rpmbuild $
#
# Copyright (c) 2006 Mike Arnold <rpmpackaging@razorsedge.org>
#
# Please submit bugfixes or comments via http://rpm.razorsedge.org/bugs/
#

# Run rpmbuild with '--define="snapshot 200509281705"' to build a snapshot.

%define HOBBITUSER %([ $HOBBITUSER ] && echo $HOBBITUSER || echo "hobbit" )

Summary: Hobbit Network Monitor - server
Name: hobbit
%{!?snapshot:Version: 4.1.2p1}
%{?snapshot:Version: %{snapshot}}
Release: %RErelease 3
Epoch: 3
License: GPL
%if "%_vendor" == "redhat"
Group: System Environment/Daemons
BuildRequires: fping, openssl-devel, pcre-devel, rrdtool-devel, openldap-devel
%endif
%if "%_vendor" == "suse"
Group: System/Monitoring
BuildRequires: fping, openssl-devel, pcre, rrdtool, openldap2-devel
PreReq: %insserv_prereq %fillup_prereq
%endif
URL: http://hobbitmon.sourceforge.net/
%{!?snapshot:Source0: http://prdownloads.sourceforge.net/hobbitmon/%{name}-%{version}.tar.gz}
%{?snapshot:Source0: http://www.hswn.dk/beta/hobbit-snapshot.tar.gz}
Source1: hobbit.init.redhat
Source2: hobbit.logrotate
Source3: hobbit.sysconfig.redhat
Source4: hobbit-client.init.redhat
Source5: hobbit-client.sysconfig.redhat
Source6: hobbit.init.suse
Source7: hobbit-client.init.suse
Source8: hobbit.sysconfig.suse
Source9: hobbit-client.sysconfig.suse
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: fping, rrdtool, pcre

%description
Hobbit is a system for monitoring your network servers and
applications. It is heavily inspired by the Big Brother
tool, but is a complete re-implementation with a lot of added
functionality and performance improvements.

These are the Hobbit files for using this machine as a BBDISPLAY,
BBNET, or BBPAGER host.

%package client
Summary: Hobbit Network Monitor - client
%if "%_vendor" == "redhat"
Group: System Environment/Daemons
BuildRequires: openssl-devel, pcre-devel, rrdtool-devel, openldap-devel
%endif
%if "%_vendor" == "suse"
Group: System/Monitoring
BuildRequires: openssl-devel, pcre, rrdtool, openldap2-devel
PreReq: %insserv_prereq %fillup_prereq
%endif
Requires: pcre

%description client
Hobbit is a system for monitoring your network servers and
applications. It is heavily inspired by the Big Brother
tool, but is a complete re-implementation with a lot of added
functionality and performance improvements.

These are the Hobbit files for using this machine as a client.

%prep
%{!?snapshot:%setup -q}
%{?snapshot:%setup -n snapshot -q}
 ENABLESSL=y \
 ENABLELDAP=y \
 ENABLELDAPSSL=y \
 BBUSER=%HOBBITUSER \
 BBTOPDIR=%{_libexecdir}/hobbit \
 BBVAR=%{_localstatedir}/lib/hobbit \
 BBHOSTURL=/hobbit \
 CGIDIR=%{_libexecdir}/hobbit/cgi-bin \
 BBCGIURL=/hobbit-cgi \
 SECURECGIDIR=%{_libexecdir}/hobbit/cgi-secure \
 SECUREBBCGIURL=/hobbit-seccgi \
 HTTPDGID=apache \
 BBLOGDIR=%{_localstatedir}/log/hobbit \
 BBHOSTNAME=localhost \
 BBHOSTIP=127.0.0.1 \
 MANROOT=%{_mandir} \
 BARS=all \
 USENEWHIST=y \
 PIXELCOUNT=960 \
 INSTALLBINDIR=%{_libexecdir}/hobbit/server/bin \
 INSTALLETCDIR=%{_sysconfdir}/hobbit \
 INSTALLWEBDIR=%{_sysconfdir}/hobbit/web \
 INSTALLEXTDIR=%{_libexecdir}/hobbit/server/ext \
 INSTALLTMPDIR=%{_localstatedir}/lib/hobbit/tmp \
 INSTALLWWWDIR=%{_localstatedir}/lib/hobbit/www \
 ./configure

%build
PKGBUILD=1 %{__make}

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
INSTALLROOT=$RPM_BUILD_ROOT PKGBUILD=1 %{__make} install
%{__cp} ${RPM_BUILD_ROOT}%{_sysconfdir}/hobbit/hobbitlaunch.cfg %{_tmppath}/hobbitlaunch.cfg.$$
%{__sed} 's/^\[hobbitclient\]/\[hobbitclient\]\n\tDISABLED/' %{_tmppath}/hobbitlaunch.cfg.$$ > ${RPM_BUILD_ROOT}%{_sysconfdir}/hobbit/hobbitlaunch.cfg
%{__rm} %{_tmppath}/hobbitlaunch.cfg.$$
%if "%_vendor" == "redhat"
%{__install} -m 0755 -D %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/hobbit
%{__install} -m 0755    %{SOURCE4} ${RPM_BUILD_ROOT}%{_initrddir}/hobbit-client
%{__install} -m 0644 -D %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/hobbit
%{__install} -m 0644    %{SOURCE5} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/hobbit-client
%{__install} -d ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d
%{__mv} ${RPM_BUILD_ROOT}%{_sysconfdir}/hobbit/hobbit-apache.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/
%endif
%if "%_vendor" == "suse"
%{__install} -m 0755 -D %{SOURCE6} ${RPM_BUILD_ROOT}%{_initrddir}/hobbit
%{__install} -m 0755    %{SOURCE7} ${RPM_BUILD_ROOT}%{_initrddir}/hobbit-client
#%{__install} -m 0644 -D %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/hobbit
#%{__install} -m 0644    %{SOURCE9} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/hobbit-client
%{__install} -m 644 -D %{SOURCE8} ${RPM_BUILD_ROOT}%{_localstatedir}/adm/fillup-templates/sysconfig.hobbit
%{__install} -m 644    %{SOURCE9} ${RPM_BUILD_ROOT}%{_localstatedir}/adm/fillup-templates/sysconfig.hobbit-client
%{__install} -d ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd
%{__mv} ${RPM_BUILD_ROOT}%{_sysconfdir}/hobbit/hobbit-apache.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/
%{__install} -d ${RPM_BUILD_ROOT}%{_sbindir}
%{__ln_s} ../../etc/init.d/hobbit ${RPM_BUILD_ROOT}%{_sbindir}/rchobbit
%{__ln_s} ../../etc/init.d/hobbit-client ${RPM_BUILD_ROOT}%{_sbindir}/rchobbit-client
%endif
%{__install} -m 0644 -D %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/hobbit
%{__install} -d ${RPM_BUILD_ROOT}%{_bindir}
%{__ln_s} %{_libexecdir}/hobbit/server/bin/{bb,bbcmd} ${RPM_BUILD_ROOT}%{_bindir}/
rmdir ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/tmp
rmdir ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/logs
%{__install} -d ${RPM_BUILD_ROOT}%{_localstatedir}/lib/hobbit-client
%{__ln_s} %{_localstatedir}/lib/hobbit-client ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/tmp
%{__ln_s} %{_localstatedir}/log/hobbit ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/logs
%{__cp} ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/etc/hobbitclient.cfg %{_tmppath}/hobbitclient.cfg.$$
%{__sed} -e's!^BBDISP=.*!include %{_localstatedir}/run/hobbitclient-runtime.cfg!' %{_tmppath}/hobbitclient.cfg.$$ | %{__grep} -v "^BBDISPLAYS=" > ${RPM_BUILD_ROOT}%{_libexecdir}/hobbit/client/etc/hobbitclient.cfg
%{__rm} %{_tmppath}/hobbitclient.cfg.$$
%{__install} -m 0644 -D /dev/null ${RPM_BUILD_ROOT}%{_localstatedir}/run/hobbitclient-runtime.cfg

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%pre
getent passwd %HOBBITUSER >/dev/null 2>&1
if [ $? -ne 0 ]
then
  groupadd -g 104 %HOBBITUSER || true
  useradd -u 104 -g %HOBBITUSER -c "Hobbit Daemon" -d %{_libexecdir}/hobbit %HOBBITUSER
fi

%post
%if "%_vendor" == "redhat"
chkconfig --add hobbit
%endif
%if "%_vendor" == "suse"
%fillup_and_insserv hobbit
%endif

%preun
%if "%_vendor" == "redhat"
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  service hobbit stop > /dev/null 2>&1 || :
  chkconfig --del hobbit
fi
%endif
%if "%_vendor" == "suse"
%if "%suse_version" >= "900"
%stop_on_removal hobbit
%else
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /etc/init.d/hobbit stop > /dev/null 2>&1 || :
fi
%endif
%endif

%postun
%if "%_vendor" == "redhat"
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  service hobbit condrestart > /dev/null 2>&1
else
  :
  #userdel %HOBBITUSER 2>/dev/null || :
  #groupdel %HOBBITUSER 2>/dev/null || :
fi
%endif
%if "%_vendor" == "suse"
%if "%suse_version" >= "900"
%restart_on_update hobbit
%else
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /etc/init.d/hobbit try-restart > /dev/null 2>&1
fi
%endif
%insserv_cleanup
%endif

%pre client
getent passwd %HOBBITUSER >/dev/null 2>&1
if [ $? -ne 0 ]
then
  groupadd -g 104 %HOBBITUSER || true
  useradd -u 104 -g %HOBBITUSER -c "Hobbit Daemon" -d %{_libexecdir}/hobbit %HOBBITUSER
fi

%post client
%if "%_vendor" == "redhat"
chkconfig --add hobbit-client
%endif
%if "%_vendor" == "suse"
%fillup_and_insserv -n -y hobbit-client
%endif

%preun client
%if "%_vendor" == "redhat"
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  service hobbit-client stop > /dev/null 2>&1 || :
  chkconfig --del hobbit-client
fi
%endif
%if "%_vendor" == "suse"
%if "%suse_version" >= "900"
%stop_on_removal hobbit-client
%else
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /etc/init.d/hobbit-client stop > /dev/null 2>&1 || :
fi
%endif
%endif

%postun client
%if "%_vendor" == "redhat"
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  service hobbit-client condrestart > /dev/null 2>&1
else
  :
  #userdel %HOBBITUSER 2>/dev/null || :
  #groupdel %HOBBITUSER 2>/dev/null || :
fi
%endif
%if "%_vendor" == "suse"
%if "%suse_version" >= "900"
%restart_on_update hobbit-client
%else
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /etc/init.d/hobbit-client try-restart > /dev/null 2>&1
fi
%endif
%insserv_cleanup
%endif

%files
%defattr(-,root,root)
%doc README Changes* COPYING CREDITS
%config(noreplace) %{_sysconfdir}/hobbit/
%if "%_vendor" == "redhat"
%config(noreplace) %{_sysconfdir}/httpd/conf.d/hobbit-apache.conf
%config(noreplace) %{_sysconfdir}/sysconfig/hobbit
%endif
%if "%_vendor" == "suse"
%config(noreplace) %{_sysconfdir}/httpd/hobbit-apache.conf
%{_sbindir}/rchobbit
%config %{_localstatedir}/adm/fillup-templates/sysconfig.hobbit
%endif
%{_initrddir}/hobbit
%{_sysconfdir}/logrotate.d/hobbit
%{_bindir}/*
%dir %{_libexecdir}/hobbit
%{_libexecdir}/hobbit/cgi-bin
%{_libexecdir}/hobbit/cgi-secure
%{_libexecdir}/hobbit/server
%doc %{_mandir}/*/*
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/acks
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/data
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/disabled
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/hist
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/histlogs
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/logs
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/rrd
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/tmp
%attr(-, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit/www
%{_localstatedir}/lib/hobbit/www/gifs
%{_localstatedir}/lib/hobbit/www/help
%attr(-, %HOBBITUSER, %HOBBITUSER) %{_localstatedir}/lib/hobbit/www/html
%dir %{_localstatedir}/lib/hobbit/www/menu
%{_localstatedir}/lib/hobbit/www/menu/README
%config %{_localstatedir}/lib/hobbit/www/menu/menu.js
%config %{_localstatedir}/lib/hobbit/www/menu/menu.css
%config %{_localstatedir}/lib/hobbit/www/menu/menu_items.js
%config %{_localstatedir}/lib/hobbit/www/menu/menu_tpl.js
%attr(-, %HOBBITUSER, %HOBBITUSER) %{_localstatedir}/lib/hobbit/www/notes
%attr(775, %HOBBITUSER, apache) %dir %{_localstatedir}/lib/hobbit/www/rep
%attr(775, %HOBBITUSER, apache) %dir %{_localstatedir}/lib/hobbit/www/snap
%attr(-, %HOBBITUSER, %HOBBITUSER) %{_localstatedir}/lib/hobbit/www/wml
%attr(755, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/log/hobbit

%files client
%defattr(-,root,root)
%doc README* Changes* COPYING CREDITS
%{_initrddir}/hobbit-client
%if "%_vendor" == "redhat"
%config(noreplace) %{_sysconfdir}/sysconfig/hobbit-client
%endif
%if "%_vendor" == "suse"
%{_sbindir}/rchobbit-client
%config %{_localstatedir}/adm/fillup-templates/sysconfig.hobbit-client
%endif
%{_libexecdir}/hobbit/client
%attr(755, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/lib/hobbit-client
%attr(755, %HOBBITUSER, %HOBBITUSER) %dir %{_localstatedir}/log/hobbit
%ghost %{_localstatedir}/run/hobbitclient-runtime.cfg

%changelog
* Tue May 30 2006 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2p1-3
- Added support for SuSE 8.2.

* Sun Dec 11 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2p1-2
- Rebuilt in new build system.

* Mon Nov 14 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2p1-1
- Release version 4.1.2p1.

* Mon Nov 14 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2p1-1
- Release version 4.1.2p1.

* Tue Oct 11 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2-1
- Release version 4.1.2.

* Wed Oct 05 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.2-0rc1
- Release Candidate 1.

* Thu Sep 29 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> snapshot
- Disabled hobbitclient in hobbitlaunch.cfg.
- Added /var/run/hobbitclient-runtime.cfg to %files.
- Moved /usr/lib (_libdir) to /usr/libexec (_libexecdir). Updated init scripts.

* Wed Sep 28 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> snapshot
- Added the ability to rpmbuild nightly snapshots.
- Fixed up BuildRoot and Group.
- Abstracted directories into variables.
- Removed patch to not chown files - fixed upstream.

* Tue Sep 20 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.1-5
- Applied logrotate patch from Peter Welter.
- Added /etc/sysconfig/hobbit file (moved from /etc/default/hobbit).
- Added hobbit-client init script from 4.1.2 snapshot.
- Rewote hobbit server init script to conform to RedHat standards.
- Rewote hobbit client init script to conform to RedHat standards.

* Mon Aug 29 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.1-4
- Split package into client and server.

* Fri Aug 26 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.1-3
- Condensed the attributes in the file list.
- Symlinked /usr/lib/hobbit/client/tmp and /usr/lib/hobbit/client/log to
  /var/lib/hobbit.

* Tue Jul 26 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 4.1.1-2
- Added patch to not chown files since we are not building as root.
- Uncommented BuildRequires.

